/*
 * Class.java
 *
 * Created on December 1, 2003, 11:26 AM
 */

/**
 *
 * @author  mdowman
 */

import javax.swing.*;
import java.util.*;
import java.awt.*;
import java.io.File;
import javax.swing.filechooser.*;
import java.io.File;
import javax.swing.ImageIcon;
import java.awt.event.*;

interface UnitScaler {
    double scale(double value);
}

/* Not Needed I am using DefaultListModel
 *
 class MyListModel extends javax.swing.AbstractListModel { // Make a custom Abstract List model which can be changed dynamically. Is used for materialRegionList, and other JLists.
    Vector listContents=new Vector(); // Initialise the list with no items.
    public int getSize() { return listContents.size(); }
    public Object getElementAt(int i) { return listContents.get(i); }
 
    void clearList() {
        listContents.clear();
    }
 
    void addItem(String newItem) {
        listContents.add(newItem);
    }
}*/

interface Greek { // Defines unicode values for special characters (including some greek ones).
    static final char alpha=0x03B1;
    static final char lambda=0x03BB;
    static final char greekk=0x03BA;
    static final char sub0=0x2080; // subscript zero.
    static final char sub1=0x2081;
//    static final char subz= // Not available in unicode?
//    static final char subp= // Not available in unicode?
    static final String Edot=""+(char)0x0045+(char)0x0307;  
}

class Colours extends Color {
    static final Color purple=new Color(102,0,204);
    static final Color brown=new Color(102,51,0);
    static final Color grey=new Color(54, 54, 54);
    static final Color brightPink=new Color(255,0,222);
    
    static int nextColourIndex=-1;
    static final Color[] colourSequence={ red, blue, green, yellow, pink, orange, purple, brown, cyan, grey };
    
    Colours() {
        super(0); // This is just a dummy call to keep the compiler happy. No objects of this class will ever be made.
    }
    
    static Color nextColour() {
        if (nextColourIndex==colourSequence.length-1) { // If index is already pointing at the last colour, then make it -1, so that when we move on to the next colour it will point at the first one.
            nextColourIndex=-1;
        }
        ++nextColourIndex;
        return colourSequence[nextColourIndex];
    }
    
    static final double maximumExpectedTemperature=1000; // These define the limits of temperature we expect to see, so intermediate temperatures will be graded.
    static final double minimumExpectedTemperature=0;

    static Color temperature2Colour(double temperature) { // Returns a red colour, the higher the temperature the lighter the red.
        return new Color((float)(Math.min(1.0, (Math.max(0.0, (temperature-minimumExpectedTemperature))/(maximumExpectedTemperature-minimumExpectedTemperature)))*0.7+0.3), 0.0F, 0.0F);
    }
    
    static Color RGB2JavaFormat(double red, double green, double blue) {
        return new Color((float)Math.min(Math.max(red, 0.0), 1.0), (float)Math.min(Math.max(green, 0.0), 1.0), (float)Math.min(Math.max(blue, 0.0), 1.0)); // We need to round the colour components to a max of 1 and a minimum of 0, otherwise the constructor for Color throws an exception.
    }

    static double javaFormat2R(Color colour) { // Get the red component of the colour (in the range 0-1);
        return colour.getRGBColorComponents(null)[0];
    }

    static double javaFormat2G(Color colour) {
        return colour.getRGBColorComponents(null)[1];
    }
    
    static double javaFormat2B(Color colour) {
        return colour.getRGBColorComponents(null)[2];
    }
    
    static Color contrast(Color colour) { // Return either black or white, depending on which will contrast the best against colour. (So white if colour is dark, black if it is light.)
        if ((colour.getRed()+colour.getBlue()+colour.getGreen())>382) { // If the chosen colour is light
            return java.awt.Color.black;
        } else {
            return java.awt.Color.white;
        }
    }

}

class Statics { // These are static functions that can't be put where they should be because of Java restrictions on where you can put static functions.
    static String getBoundaryPropertyEllipsisName(int property) {
        if (property==MainWindow.BackgroundImagePanel.Boundary.temperature)
            return "Temp";
        if (property==MainWindow.BackgroundImagePanel.Boundary.stress_x)
            return "Stress_x"; 
        if (property==MainWindow.BackgroundImagePanel.Boundary.stress_z)
            return "Stress_z";
        if (property==MainWindow.BackgroundImagePanel.Boundary.velocity_x)
            return "Velocity_x";
        if (property==MainWindow.BackgroundImagePanel.Boundary.velocity_z)
            return "Velocity_z";
        return null; // We should never get here!
    }
    
    static char string2Char(String string) { // Convert the string to a Char, by taking the first non white space char.
        int index=0;
        while (index<string.length()) {
            if (string.charAt(index)=='\t' || string.charAt(index)==' ') {
                ++index;
            } else {
                break;
            }
        }
        
        return string.charAt(index);
    }
        
    static String boolean2filledOrUnfilled(boolean filled) {
        if (filled)
            return "filled";
        else
            return "unfilled";
    }
    
    static boolean filledOrUnfilled2Boolean(String filledOrUnfilled) {
        if (filledOrUnfilled.equals("filled"))
            return true;
        else 
            return false;
    }
    
    static String boolean2OnOff(boolean theBool) {
        if (theBool)    
            return "on\n";
        else
            return "off\n";
    }
    
    static String nthItem(String list, int n) throws ParameterIncompatibilityException { // Returns the nth item from the comma separated list.
//        System.out.println("nth Item is called with parameters "+list+" and "+n);
        if (list.equals(""))
            throw new ParameterIncompatibilityException();
        
        int index=0;
        
        for (int commasFound=0; commasFound<n-1; ++commasFound) {
            if (index>=list.length()) // If we've reached the end of the string without finding enough commas, throw an exception.
                throw new ParameterIncompatibilityException();
            while (list.charAt(index)!=',') { // Search through the string for the commas separating the list items.
                ++index;
                if (index>=list.length()) // If we've reached the end of the string without finding enough commas, throw an exception.
                    throw new ParameterIncompatibilityException();
            }
            
            ++index; // Skip over the comma
        } // And now start looking for the next comma.
        
        if (index>=list.length()) // If there's nothing after the comma, throw an exception.
            throw new ParameterIncompatibilityException();
//        System.out.println("Index in nth:"+index);
        index=skipWhiteSpaceInString(list, index); // Skip over any white space to the start of the item.
//        System.out.println("nthItem is returning "+parseWordInString(list, index));
        return parseWordInString(list, index); // And parse the next word from the string.
    }
    
    static double safeNthReal(String list, int n) { // This is like nthReal, but if there's an error, instead of throwing an exception it just returns 0.
        try {
            return nthReal(list, n);
        } catch (Exception ex) { // catch all exceptions
            return 0;
        }
    }
    
    static double nthReal(String list, int n) throws ParameterIncompatibilityException, ParameterSyntaxErrorException {
//        System.out.println("nth real is called with parameters "+list+" and "+n);
        
        try {
            return Double.parseDouble(nthItem(list, n));
        } catch (NumberFormatException exception) {
//            System.out.println("nthReal is throwing a syntax error exception");
            throw new ParameterSyntaxErrorException();
        }
    }
    
    static int nthInteger(String list, int n) throws ParameterIncompatibilityException, ParameterSyntaxErrorException {
        try {
            return Integer.parseInt(nthItem(list, n));
        } catch (NumberFormatException exception) {
//            System.out.println("nthInteger is throwing a syntax error exception");
            throw new ParameterSyntaxErrorException();
        }
    }
    
    static String parseWordInString(String string, int indexOfStartOfWord) { // Parse all the characters from this point until the end of line, end of the file, or white space OR A COMMA is found. This may be no characers, in which case a blank string is returned.
        int indexOfEndOfWord=indexOfStartOfWord; // Start looking for the end of the word starting at the position of its start.
        while (indexOfEndOfWord<string.length() && string.charAt(indexOfEndOfWord)!=',' && string.charAt(indexOfEndOfWord)!=' ' && string.charAt(indexOfEndOfWord)!='\t' && string.charAt(indexOfEndOfWord)!='\n')
            ++indexOfEndOfWord;
        
        return string.substring(indexOfStartOfWord, indexOfEndOfWord); // 1 need not be added to end of word index because index already point to the character after the end of the word, unless the word is just the empty string.
    }
    
    static int skipWhiteSpaceInString(String string, int index) {
        while (string.charAt(index)==' ' || string.charAt(index)=='\t') // skip over any white space.
            ++index;
        
        return index;
    }

} // End of class Statics


class MessageBoxes {
    public static void warnAboutBadDouble(Component parentWindow) {
        JOptionPane.showMessageDialog(parentWindow,"The text you have entered does not conform to a valid number. The parameter has not been changed.", "Error", JOptionPane.ERROR_MESSAGE);
    }
    static void warnAboutBadInteger(Component parentWindow) {
        JOptionPane.showMessageDialog(parentWindow, "The text you have entered does not conform to a valid integer. The parameter has not been changed.", "Error", JOptionPane.ERROR_MESSAGE);
    }    
    public static void warnAboutDoubleSetToZero(Component parentWindow) {
        JOptionPane.showMessageDialog(parentWindow,"The text you have entered does not conform to a valid number. The parameter has been set to zero.", "Error", JOptionPane.ERROR_MESSAGE);
    }
    public static void warnAboutZero(Component parentWindow) {
        JOptionPane.showMessageDialog(parentWindow,"This parameter cannot be set to zero. It has not been changed.", "Error", JOptionPane.ERROR_MESSAGE);
    }
    public static void warnAboutIntegerSetToZero(Component parentWindow) {
        JOptionPane.showMessageDialog(parentWindow,"The value you have entered does not conform to a valid integer. The parameter has been ser to zero.", "Error", JOptionPane.ERROR_MESSAGE);
    }
    public static void warnAboutDuplicateParameter(Component parentWindow, String parameterName) {
        JOptionPane.showMessageDialog(parentWindow, "The input file contains more than one setting for the parameter \""+parameterName+"\".\nAll occurences of this parameter other than the first one have been removed.", "Warning", JOptionPane.WARNING_MESSAGE);
    }
    static void warnAboutNegative(Component parentWindow) {
        JOptionPane.showMessageDialog(parentWindow, "This parameter cannot be set to a negative value. It has not been changed.", "Error", JOptionPane.ERROR_MESSAGE);
    }
    static void warnAboutDoubleBelowMinimum(double minimumDoubleValue, Component parentWindow) {
        JOptionPane.showMessageDialog(parentWindow, "The minimum value for this parameter is "+Useful.double2String(minimumDoubleValue)+". The parameter's value has therefore not been changed.", "Error", JOptionPane.ERROR_MESSAGE);
    }
    static void warnAboutDoubleAboveMaximum(double maximumDoubleValue, Component parentWindow) {
        JOptionPane.showMessageDialog(parentWindow, "The maximum value for this parameter is "+Useful.double2String(maximumDoubleValue)+". The parameter's value has therefore not been changed.", "Error", JOptionPane.ERROR_MESSAGE);
    }
    
}

/* Utils.java is a 1.4 example used by FileChooserDemo2.java. */ // Part of it has been deleted by me.
class Utils {
    public final static String jpeg = "jpeg";
    public final static String jpg = "jpg";
    public final static String gif = "gif";
    public final static String tiff = "tiff";
    public final static String tif = "tif";
    public final static String png = "png";
    
    /*
     * Get the extension of a file.
     */
    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');
        
        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
    
}

class Useful {
    
    private static final int numberOfSignificantFigures=5;
    
    static String double2String(double theDouble) {
        String doubleString=""+theDouble;
        String mantissa=getMantissa(doubleString);
        int exponent=getExponent(doubleString);
        String sign=getSign(doubleString);
        
        //        System.out.println(sign+" '"+mantissa+"' "+exponent);
        
        // If exponent is -3 to 4 print normally
        if (exponent>=-3 && exponent<=4) {
            return sign+placePoint(mantissa, exponent);
        } else { // If it's outside this range use E notation.
            if (mantissa.length()==1) // If we don't need a point
                return sign+mantissa+"E"+exponent;
            else
                return sign+mantissa.charAt(0)+"."+mantissa.substring(1)+"E"+exponent;
        }
    }
    
    private static String placePoint(String mantissa, int exponent) {
        if (mantissa.equals("")) // If the value is zero
            return "0";
        
        if (mantissa.length()<exponent+1)
            mantissa=addTrailingZeros(mantissa, exponent+1); // If the mantissa is too short, add trailing zeros to make it exponent+1 long.
        
        if (exponent>=0) { // If there is a significant figure to the left of the point.
            if (mantissa.length()>exponent+1) // If the number needs a point
                return mantissa.substring(0,exponent+1)+'.'+mantissa.substring(exponent+1);
            else
                return mantissa; // Otherwise just return the mantissa (this is OK, because we've padded it with zeros if necessary, effectively placing the point).
        } else { // If the point is to the left of the most sig digit.
            return "0."+zeros((-exponent)-1)+mantissa;
        }
    }
    
    private static String addTrailingZeros(String string, int desiredLength) {
        return string+zeros(desiredLength-string.length());
    }
    
    private static String zeros(int numberOfZeros) {
        String zeros="";
        while (numberOfZeros>0) {
            zeros+='0';
            --numberOfZeros;
        }
        return zeros;
    }
    
    private static String getSign(String doubleString) {
        if (doubleString.charAt(0)=='-')
            return "-";
        else
            return "";
    }
    
    private static int getExponent(String doubleString) {
        int exponentLocation=doubleString.indexOf('E');
        int pointLocation=doubleString.indexOf('.');
        assert(pointLocation!=-1); // Java doubles always seem to be printed with a point.
        int firstSignificantDigitLocation=getIndexOfFirstSignificantDigit(doubleString);
        
        //        System.out.println(";"+firstSignificantDigitLocation);
        if (firstSignificantDigitLocation==-1) // If there are no significant digits (number is 0).
            return 0;
        
        int exponent; // Get the exponent based on the location of the point and the first sig digit.
        if (firstSignificantDigitLocation<pointLocation) { // If the first sig digit is to the left of the point.
            exponent=pointLocation-firstSignificantDigitLocation-1;
        } else { // If the first sig digit is to the left of the point.
            exponent=pointLocation-firstSignificantDigitLocation;
        }
        
        if (exponentLocation!=-1) { // If there is an exponent, we need to take account of it.
            exponent=exponent+Integer.parseInt(doubleString.substring(exponentLocation+1)); // Read the exponent, and combine it with the one we already have.
        }
        
        return exponent;
    }
    
    private static int getIndexOfFirstSignificantDigit(String doubleString) {
        int index=0;
        int exponentLocation=doubleString.indexOf('E'); // We want to search up to the exponent, or the end of the string if there is no exponent.
        if (exponentLocation==-1)
            exponentLocation=doubleString.length();
        while (index<exponentLocation) {
            if (doubleString.charAt(index)>='1' && doubleString.charAt(index)<='9') // If we've found a significant digit...
                return index; // return its index.
            ++index;
        }
        
        //        System.out.println("*");
        assert doubleString.equals("0.0"); // If we can't find a significant digit, the number must be 0.
        return -1; // Signal no significant digits found.
    }
    
    private static String getMantissa(String doubleString) { // Get the required number of mantissa digits, correctly rounded.
        doubleString=removeExponent(doubleString);
        doubleString=removeLeadingZeros(doubleString);
        doubleString=removeTrailingZeros(doubleString);
        //        System.out.println(doubleString);
        String mantissaDigits=getDigits(doubleString);
        //       System.out.println(mantissaDigits);
        return trim(mantissaDigits); // Chop off redudant digits and round as necessary
    }
    
    
    private static String getDigits(String doubleString) {
        String mantissa="";
        int index=0;
        while (index<doubleString.length()) { // Go through and get all the digits in order, ignoring any - or . .
            if (doubleString.charAt(index)>='0' && doubleString.charAt(index)<='9')
                mantissa=mantissa+doubleString.charAt(index);
            ++index;
        }
        return mantissa;
    }
    
    
    private static String removeExponent(String doubleString) {
        int exponentLocation=doubleString.indexOf('E');
        if (exponentLocation!=-1) return doubleString.substring(0,exponentLocation);
        return doubleString;
    }
    
    
    private static String removeLeadingZeros(String string) { // N.B. ALso removes leading point and sign. Exponent has already been removed.
        while (string.length()>0) { // Keep going as long as there's a character left.
            if (string.charAt(0)>='1' && string.charAt(0)<='9') { // If we've found a significant figure...
                return string; // we return the string in its current state.
            } else {
                string=string.substring(1); // If the first character isn't significant remove it.
            }
        }
        return ""; // We'll only get here if there are no sig figs in the whole string.
    }
    
    private static String removeTrailingZeros(String string) { // Remove trailing zeros from the mantissa part of a floating point number (also removes trailing point, and possibly the sign too). (Exponent has already been removed.)
        while (string.length()>0) { // Keep going as long as there's a character left.
            if (string.charAt(string.length()-1)>='1' && string.charAt(string.length()-1)<='9') { // If we've found a significant figure...
                return string; // we return the string in its current state.
            } else {
                string=string.substring(0, string.length()-1); // If the last character isn't significant remove it.
            }
        }
        return ""; // We'll only get here if there are no sig figs in the whole string.
    }
    
    private static String trim(String string) { // Trim the string to be the right size, rounding off as appropriate. Take account of any decimal points the string may contain.
        if (string.length()<=numberOfSignificantFigures) return string; // If the string is small enough anyway, just return.
        
        char roundingChar=string.charAt(numberOfSignificantFigures); // Find the first character we're going to get rid of.
        
        string=string.substring(0,numberOfSignificantFigures); // Throw away all the digits we don't want.
        if (roundingChar>='5') { // If we need to round up.
            int index=numberOfSignificantFigures-1;
            string=round(string, index);
        }
        
        return string;
    }
    
    // N.B. A revursive function. Round up the digit of string pointed to by index. Leave anything on the right of that unchanged as it will already have been rounded.
    private static String round(String string, int index) {
        if (string.charAt(index)=='9') { // If this digit will overflow.
            string=string.substring(0,index)+"0"+string.substring(index+1); // Round the digit up.
            if (index==0) { // If the first digit has overflowed.
                string="1"+string.substring(0,string.length()-1); // Put a one in front and chop the last digit.
                string=chopTrailingPoint(string); // Chop any trailing point that might now exist.
            } else { // If it's not the first digit that's overflowed, round up the the one on the left of it.
                string=round(string, index-1);
            }
        } else { // Otherwise just increase the number by one - and there's no need to do anything to any other digits.
            //            System.out.println("["+string);
            //           System.out.println(string.substring(0,index));
            //            System.out.println((string.charAt(index)+1));
            //            System.out.println(string.substring(index+1));
            string=string.substring(0,index)+((char)(string.charAt(index)+1))+string.substring(index+1); // Round the digit up.
            //            System.out.println("]"+string);
        }
        return string; // When it's all done, return the string.
    }
    
    private static String chopTrailingPoint(String string) {
        if (string.charAt(string.length()-1)=='.') return string.substring(0, string.length()-1);
        else return string;
    }
    
    static String chopAnyTrailingComma(String string) { // This isn't part of the double rounding function.
        if (string.length()==0) // If the string is empty, just return the empty string.
            return string;
        if (string.charAt(string.length()-1)==',')
            return string.substring(0, string.length()-1);
        else
            return string;
    }
    
} // End of class Useful

class ParameterNotFoundException extends Exception {
}

class DuplicateParameterException extends Exception {
}

class ParameterSyntaxErrorException extends Exception {
}

class ParameterIncompatibilityException extends Exception {
}




